package fi.jyu.intellij.comtest.rider.actions

import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import fi.jyu.intellij.comtest.common.util.runWithRefresh
import fi.jyu.intellij.comtest.rider.ComTestRunner
import fi.jyu.intellij.comtest.rider.util.hasRiderSolution

/**
 * Action to run ComTest on the current .NET solution.
 */
@Suppress("MissingActionUpdateThread") // Seems to require at least 2022.2.3
class ComTestGenerateDotNetSolutionAction : AnAction() {
    override fun actionPerformed(e: AnActionEvent) {
        // Project presence checked in update()
        val proj = e.project ?: return

        runWithRefresh(proj) {
            ComTestRunner.generateForDotNetSln(proj)
        }
        //RiderUnitTestRunContextAction

//        // FIXME: Waiting for project reload and running unit tests automatically. Right now timing seems to be difficult
//        VfsWatchRootHost.getInstance(proj).sync()
//        SolutionLifecycleHost.getInstance(proj).waitSolutionBuilderIsReady()
//        // https://dploeger.github.io/intellij-api-doc/com/intellij/openapi/project/DumbService.html
//        val ds = proj.service<DumbService>()
//        WorkspaceModelUpdater.getInstance(proj).syncIfPossible()
//        thread {
//            Thread.sleep(500)
//            ds.waitForSmartMode()
//            ds.smartInvokeLater({
//                val act = ActionManagerEx.getInstanceEx().getAction("RiderUnitTestRunSolutionAction")!!
//                act.update(e)
//                act.actionPerformed(e)
//            }, ModalityState.NON_MODAL)
//        }
    }

    override fun update(e: AnActionEvent) {
        e.presentation.isEnabled = e.project?.hasRiderSolution ?: false
    }
}